#Get data
Coal=c(4, 5, 4, 1, 0, 4, 3, 4, 0, 6, 3, 3, 4, 0, 2, 6, 3, 3, 5, 4, 
5, 3, 1, 4, 4, 1, 5, 5, 3, 4, 2, 5, 2, 2, 3, 4, 2, 1, 3, 2, 2, 
1, 1, 1, 1, 3, 0, 0, 1, 0, 1, 1, 0, 0, 3, 1, 0, 3, 2, 2, 0, 1, 
1, 1, 0, 1, 0, 1, 0, 0, 0, 2, 1, 0, 0, 0, 1, 1, 0, 2, 3, 3, 1, 
1, 2, 1, 1, 1, 1, 2, 3, 3, 0, 0, 0, 1, 4, 0, 0, 0, 1, 0, 0, 0, 
0, 0, 1, 0, 0, 1, 0, 1)

n=length(Coal)
n_1=n-1

#Calculate cumulative sum of data

s<-rep(0,n_1)
for(i in 1:n_1) s[i]=sum(Coal[1:i])
sCoal=sum(Coal)

#Model M2 - posterior probabilities
#Calculate Logs for numerical stability 
#ignore common factor of 1/4(n-1)

logpr=rep(0,n_1)

for(t in 1:n_1){
  logpr[t]=lgamma(s[t]+1)+lgamma(sCoal-s[t]+1)-(s[t]+1)*log(t+0.5)-(sCoal-s[t]+1)*log(n-t+0.5)
}

#Remove common factor from logpr - max_value

logprmax=max(logpr)

pr=exp(logpr-logprmax)
pr=pr/sum(pr) #normalise distribution
t=1851:1961                               # years
t[pr==max(pr)]				  # mode of marginal posterior of change point at this year
max(pr)

barplot(pr,names=1851:1961,main="Posterior Probability of Changepoint",xlab="Year",ylab="Probability")

#Calcute log of evidences - ignore product of factorials which is common

#Model 1

LogEv1=log(0.5)+lgamma(sCoal+1)-(sCoal+1)*log(n+0.5)

#Model 2

LogEv2=log(1/(4*n_1))+logprmax+log(sum(exp(logpr-logprmax))) # include factor of 1/444 - subtract and additition of logprmax is for stability

#Posterior probability of Model 1

Postprob1=0.5*exp(LogEv1)/(0.5*exp(LogEv1)+0.5*exp(LogEv2))
Postprob2=1-Postprob1
Postprob1
Postprob2