# Basic Algebra
a=3
b=6
a+b
b-a
a*b
b/a
abs(a-b)
a^2
a^(-2)
b^(1/2)
b^(-1/3)
sqrt(b)
x=3
logx=log(x)
exp(logx)

# Vectors
x=c(1,2,3,-4)
x[3]
sum(x)
y=c(5,-6,7,8)
y[2:3]
n=length(y)
n
t(x)     # transpose
x*y      # element by element
x%*%y    # the result is scalar
x%*%t(y) # the result is matrix
x^2
x%*%x
1/y
x=rep(0,10)
x
for (i in 1:10) x[i]=10*i
x
x[c(1,5,7)]
y=1:4
y
i=rep(2,4)
i
x=rep(y,2)
x
z=rep(y,i)
z
w=rep(y,y)
w

# Matrices
A=rbind(c(1,2,3),c(4,5,6))
A
A[,1]
B=cbind(c(1,3),c(2,4))
B
B[1,]
A1=rbind(c(5,6,7),c(-5,-6,-7))
A-A1
B%*%A      # matrix multiplication
B^2        # elements to the power
B%*%B      # matrix multiplication
t(A)       # transpose
B^(-1)     # elements to the power
det(B)     # determinant
C=matrix(c(16,7,3,21),2,2)
eigen(C)   # eigenvalues and eigenvectors
solve(C)   # inverse
x=1:20
A=matrix(x,4,5)
A
B=matrix(x,4,5,byrow=T)
B
C=B[2:3,3:5]
C

# Random sample generation
n=10
sample(n)    # select a random permutation from 1 to n
x=c(8,3,5,11,9,5,4,2)
sample(x)           # randomly permute x
sample(x,replace=T) # random sampling with replacement
m=3
sample(x,m)           # sample m items from x without replacement
sample(x,m,replace=T) # sample m items from x with replacement
p=c(0.1,0.2,0.05,0.05,0.3,0.1,0.05,0.15)
sample(x,m,replace=T,prob=p) # sample m items from x with probabilities given by p

# Simulate n draws from the Normal distribution with mean equal to mu
# and standard deviation equal to sd
n=100
mu=0
sd=1
x=rnorm(n,mu,sd)
mean(x)     # sample mean
var(x)      # sample variance
n=10000
mu=10
sd=3
x=rnorm(n,mu,sd)
hist(x)

# Draw the pdf of the normal distribution
x=(-3000:3000)/1000
fx=dnorm(x,0,1)
plot(x,fx)

# Simulate from the Beta distribution
n=10000
x=rbeta(n,2,4)
hist(x)

# Draw the pdf of the beta distribution
x=(0:100000)/100000

fx1=dbeta(x,2,4)  # example 1
plot(x,fx1)

fx2=dbeta(x,10,2)  # example 2
plot(x,fx2)

fx3=dbeta(x,1,1)  # example 3
plot(x,fx3)

fx4=dbeta(x,0.5,0.5)  # example 4
plot(x,fx4)

fx5=dbeta(x,1,5)  # example 5
plot(x,fx5)



# Simulate from the Gamma distribution
n=10000
x=rgamma(n,3,5)
hist(x)

# Draw the pdf of the gamma distribution
x=(0:100000)/10000

fx1=dgamma(x,3,5)  # example 1
plot(x,fx1)

fx2=dgamma(x,10,2)  # example 2
plot(x,fx2)

fx3=dgamma(x,1,1)  # example 3
plot(x,fx3)


# Simulate from the Binomial distribution
n=10000
x=rbinom(n,10,0.7)

# Simulate from the Poisson distribution
n=10000
x=rpois(n,3)

y=3
mu=4
sd=1
dnorm(y,mu,sd)    # density
pnorm(y,mu,sd)    # distribution function

# A function that calculates the logarithm of the pdf of a normal distribution
"logdnorm" <-
function (x,mu,sd) 
{
logfx=-0.5*log(2*pi)-log(sd)-0.5*((x-mu)/sd)^2

return(logfx)
}

y=3
mu=4
sd=1
dnorm(y,mu,sd)
logfx=logdnorm(y,mu,sd)
exp(logfx)

# A function that calculates the logarithm of the pdf of a gamma distribution
"logdgamma" <-
function (x,p,q) 
{
logfx=p*log(q)+(p-1)*log(x)-lgamma(p)-x*q
return(logfx)
}

y=3
p=2
q=3
dgamma(y,p,q)
logfx=logdgamma(y,p,q)
exp(logfx)